;------------------------------------------------------------------------------
; FLI interlace picture (Funpaint) viewer
; created 1999 by Tomas Pribyl (dundera@a1.fido.cz)
; superCPU fixed by Tomas Pribyl
;
; For more information on the IDE64 project,
; please see http://sgi.felk.cvut.cz/~vorlicek/Ide/c64ide.html
; or mail to: Josef.Soucek@spt.cz
;------------------------------------------------------------------------------

; $3ff0 - $3fff FUNPAINT (MT)
; $4000 - $5fff 8*VideoRam 1
; $6000 - $73f3 GraficScreen 1
; $7f40 - $7f47 0

; $7f40 - $7fab informace pro $d021 Line 0-99
; $7fac - $7fff unused                           
; $8000 - $83e8 barvy pro COLOR RAM $d800

;tady prijde soubor presmerovat na novou adresu $c000

;($8400 - $92b0 se uklada zobrazovaci rutina)

; $c000 - $dfff 8*VideoRam 2
; $e000 - $ff3f GraficScreen 2
; $ff40 - $ffa3 dalsi informace pro $d021 Line 100-199

;Lenth 33692 bytes


;format obrazku v souboru

;0,1  start adresa - prijde odstranit
;$02-$0e  identify TEXT HEADER - "FUNPAINT (MT)"
;$0f - compress (yes/no)  1/0
;$10 - compress identify byte

;$11 - $xx - picture datas



scpu_normal   = $d07a
scpu_turbo    = $d07b
                

;definice kernalovych vektoru

cint    = $ff81
ioinit  = $ff84
ramtas  = $ff87
restor  = $ff8a
vector  = $ff8d
setmsg  = $ff90
second  = $ff93
tksa    = $ff96
memtop  = $ff99
membot  = $ff9c
scnkey  = $ff9f
settmo  = $ffa2
acptr   = $ffa5
ciout   = $ffa8
untlk   = $ffab
unlsn   = $ffae
listen  = $ffb1
talk    = $ffb4
readst  = $ffb7
setlfs  = $ffba
setnam  = $ffbd
open    = $ffc0
close   = $ffc3
chkin   = $ffc6
chkout  = $ffc9
clrchn  = $ffcc
chrin   = $ffcf
chrout  = $ffd2
load    = $ffd5
save    = $ffd8
settim  = $ffdb
rdtim   = $ffde
stop    = $ffe1
getin   = $ffe4
clall   = $ffe7
udtim   = $ffea
screen  = $ffed
plot    = $fff0
iobase  = $fff3


;dirchange =$defd    ;harddisk routines
;dircreate =$defa
;hdddelete =$def7
hddread   =$def4
hddwrite  =$def1


print_ptr0      = $fa
print_ptr1      = print_ptr0+1



                * =  $1000 

                

                jmp start_without_name
                
                
                jsr setnam                ;values from MANAGER
                jsr clall
                
                lda #$00
                sta mansign
                
                lda #<utilname_txt
                ldy #>utilname_txt
                jsr print2screen
                
                jmp skipinput
                


start_without_name = *
                jsr clall

                lda #$80
                sta mansign
                
                lda #<utilname_txt+1
                ldy #>utilname_txt
                jsr print2screen
                
                lda #<input_txt
                ldy #>input_txt
                jsr print2screen

                jsr get_filename       ;external start
                jsr setnam             ;start from manager
                
;----------------------------------------------------------------
;LOAD FILE
                
skipinput       lda #1
                ldx $ba
                ldy #0
                jsr setlfs
                jsr open
                bcc open_ok
                jmp read_status

                
open_ok         ldx #1
                jsr chkin  ;prepne soubor na vstup
                bcc chkin_ok 
                jmp read_status

                
chkin_ok        jsr chrin  ;odstrani start adresu
                jsr chrin 
                
                lda $90
                beq i1138  ;status OK
                jmp i11c0  ;cteni statusu & END.
;
                
i1138           ldy #$00
i1142           jsr chrin    ;cte hlavicku souboru
                sta $3ff0,y
                iny
                cpy #$10     ;16 znaku
                bne i1142
                
               ; ldy #0
               ; lda $90    
               ; bne i11c0    ;read status & END.
                
                ldx #$0d
i1157           lda $3ff0,x   ;test identify head
                cmp afunpaintmt,x
                bne i11cf     ;bad picture, close file
                dex
                bpl i1157
                lda $3ffe     ;kompresni byte????
                bne load_compressed
                beq load_noncompres

                
;--------------------------------------------------------------
;no valid indentification head detected
i11cf           lda #$01
                jsr close
                jsr clall
                bit mansign
                bpl skip_text
                lda #<novalid_txt
                ldy #>novalid_txt
                jsr print2screen
skip_text       jmp end_of_prg
                
                
                


                

;---------------------------------------------------------------
; LOAD STORED (noncompression) PICTURE 

load_noncompres lda #<noncompres_txt
                ldy #>noncompres_txt
                jsr print2screen
                
                ldy #<$4000
                sty $02
                lda #>$4000
                sta $03

i1167           jsr chrin         ;nahrani nekomprimovaneho obrazku
                sei     
                sty $01
                sta ($02),y
                ldx #$36 
                stx $01
                sta $d020
                cli   
               
i117d           jsr i120b     ;inkrement a pripadne presmerovani
                              ;store pointeru
                bcs i11c0     ;test EOF, read disk status & END
                lda $90
                beq i1167     ;load next byte
                bne i11c0
                



;-------------------------------------------------------------                
; DEPACKING comprimated picture
load_compressed lda #<compressed_txt
                ldy #>compressed_txt
                jsr print2screen
                
                ldy #<$4000
                sty $02
                lda #>$4000
                sta $03
                
i1188           jsr     chrin      ;nahrani komprimovaneho obrazku
                cmp     $3fff      ;znacka, pro opakovani
                bne     i119c      ;neni, bajty ulozit
                jsr     chrin      ;nacist pocet, kolikrat ulozit
                beq     i11bb      ;pocet je nula, konec souboru
                tax     
                jsr     chrin      ;bajt, ktery se ma opakovat
                jmp     i119e
;

i119c           ldx     #1      ;pouze jednou ulozit

i119e           sta     $d020
                sta     $58     ;nacteny byte
                sei     
                sty     $01
                stx     $57
i11a8           lda     $58     ;nacteny byte
                sta     ($02),y ;ulozit do pameti
                jsr     i120b   ;obsluha store adresy
                dec     $57     ;x-krat ulozit
                bne     i11a8
                ldx     #$36
                stx     $01     ;zapnout ROM
                lda     $90
                beq     i1188   ;nacist dalsi bajt

i11bb           lda     #$36    ;end of loading
                sta     $01
                cli     
;-------------------------------END of DECOMPRESSION




i11c0           lda     #1
                jsr     close
                jsr     clall
                
                lda     #0
                sta     $d020

                jsr     store_code   ;priprava zobrazovaci rutiny
                
                sta     SCPU_normal  ;vypne SuperCPU
                jsr     set_new_irq  ;nastaveni zobrazovaciho IRQ + barvy
               

press_key       lda     $dc00        ;wait until keypressed
                and     $dc01
                and     #$10
                bne     press_key
                


;-------------RESTORE ORIGINAL CONFIGURATION
i104a           lda     $d011        ;preteceni registru rastru
                bpl     i104a
                
                sei
                sta     SCPU_turbo   ;zapne SuperCPU
                lda     #%01101011
                sta     $d011
                lda     #0
                sta     $d01a
                lda     #%10000001
                sta     $dc0d
                
                lda     #$37 ;zapnout ROMky (puvodni IRQ)
                sta     $01
                
                lda     #6
                sta     $d021     ;barva
                
                ldx     #0
                lda     $0286     ;puvodni barva znaku
i106c           sta     $d800,x   ;obnovit v COLOR RAM
                sta     $d900,x
                sta     $da00,x
                sta     $db00,x
                inx     
                bne     i106c

i107b           lda     $d011
                bpl     i107b
                
                lda     #%00000011 ;graficka stranka $0000-$3fff (0)
                sta     $dd00
                lda     #%00010101 ;pocatek znaku $1000/obraz $0400
                sta     $d018      
                lda     #%00001000 ;text 40 sloupcu
                sta     $d016
                lda     #%00011011 ;text 25 radku/zapnuty VIC
                sta     $d011
                cli     

end_of_prg      lda     #0
                sta     $c6   ;buffer klavesnice 0
                rts     


;
;zadani nazvu souboru

get_filename    jsr     clrchn
                jsr     clall
                ldy     #$00
rd_filename     jsr     chrin
                sta     filename,y
                iny
                cmp     #$0d
                bne     rd_filename
                
                tya                  ;filename lenght
                ldx     #<filename
                ldy     #>filename
                rts
;----------------------------------------------                



;

read_status     jsr clrchn
                jsr clall
                bit mansign
                bpl skip_status

                
                lda #$0f   ;cislo souboru
                ldx $ba
                ldy #$0f   ;sek.adresa pro status kanal
                jsr setlfs
                
                lda #$00
                sta $b7    ;delka nazvu 0
                
                jsr open
                
                ldx #$0f
                jsr chkin  ;vstup
                
i11eb           jsr chrin
                pha
                jsr chrout
                pla
                cmp #$0d
                bne i11eb
                
                lda #$0f
                jsr close
                jsr clall

skip_status     jmp end_of_prg


;

;               s u b r o u t i n e
; inkrementuje STORE ADRESU
; pokud se doladovalo do $83e8, pak presmeruje pointer na
; $c000 a laduje se dale.
; Pokud soubor presahne adresu $ffa4, nastavuje se CY=1

i120b           inc  $02
                bne  i1211
                inc  $03

i1211           lda  $02
                ldx  $03
                cpx  #$83 ; $83e8
                bne  i1225
                cmp  #$e8 ;
                bne  i1223
                sty  $02  ; $00
                lda  #$c0 ; $c0
                sta  $03

i1223           clc
                rts
;

i1225           cpx     #$ff
                bne     i1223
                cmp     #$a4 ;$ffa4
                bne     i1223
                sec     
                rts     
; end of function i120b


;
;               s u b r o u t i n e
; ulozi na $8400 - $92a0 rozbaleny zobrazovaci kod pro obsluhu $d021
;


store_code      lda #$3b
                sta at8400+1
                
                lda #8
                sta i129b+1      ;(grafika-stranka)
                
                lda #$40
                sta i12a0+1
                
                lda #$7f 
                sta i12a0+2      ;$7f40-$7fab
                
                lda #<$8400
                sta $02
                lda #>$8400
                sta $03
                
                ldx #$d0 ; ''
                
i124d           ldy #$11
i124f           lda at8400,y ;presunuti bloku dat na $8400
                sta ($02),y
                dey
                bpl i124f 
                
                clc       ;inkrement store adresy o $12
                lda $02   ;$00
                adc #$12
                sta $02   ;$12
                bcc i1262   ;pricte #$12
                inc $03
                          
i1262           clc
                lda at8400+1
                adc #1
                and #%00000111
                ora #%00111000
                sta at8400+1
                
                lda i129b+1
                adc #$10
                and #%01111111
                sta i129b+1
                
                inc i12a0+1   ;zvetseni adresy, odkud se bere barva
                
                dex           ;konec kopirovani, uloz RTS
                beq i128f
                
                cpx #$64
                bne i124d
                
                lda #$40      ;presmerovani na $ff40-$ffa3
                sta i12a0+1
                lda #$ff
                sta i12a0+2
                bne i124d
;-----------------------------------                

i128f           ldy #0
                lda #$60         ;tohle je kod instrukce pro RTS
                sta ($02),y
                rts     
                

; end of function store_code


;
at8400          lda     #%00111011 ;jemna grafika, vicebarevny text
                                ; ($3b)
                sta     $d011

i129b           lda     #%00001000 ;pocatek grafiky + $2000 <-sem se ulozi
                sta     $d018

i12a0           lda     $ffa4   ;<- sem se ulozi spravna adresa ($7f40)
                sta     $d021   ;prepne barvu !!!!! neco duleziteho
                bit     $d3   
;------------------------------------------------------------------                


;

;               s u b r o u t i n e

set_new_irq     lda     $d011     ;test preteceni rasterline
                bpl     set_new_irq
                
                sei     
                lda     #%01101011 ;vypnuta obrazovka, jemna grafika,barevny
                sta     $d011      ;text
                
                lda     #$35 
                sta     $01
                
                ldx     #0
i12b9           lda     $8000,x    ;presune barvy
                sta     $d800,x
                lda     $8100,x
                sta     $d900,x
                lda     $8200,x
                sta     $da00,x
                lda     $8300,x
                sta     $db00,x
                inx     
                bne     i12b9
                
                lda     #%00000000  ;nastaveni videobanky $c000-$ffff
                sta     $dd00
                
                lda     #%00111000  ;screen $cc00/grafix $e000
                sta     $d018
                
                lda     #%00011001  ;40sl, barvevny mod
                sta     $d016
                
                lda     #%01111111  ;casovac CIA1
                sta     $dc0d
                lda     $dc0d
                
                lda     #%00000001  ;maskovaci registr IRQ
                sta     $d01a
                sta     $d019       ;prerusovaci registr IRQ,
                                    ;povoleni pro rastr
                
                lda     #<i1317  ;irq vector
                sta     $fffe
                lda     #>i1317
                sta     $ffff
                
                lda     #$2f
                sta     $d012    ;nastaveni rasterline

i1302           lda     $d011    ;test znamenkoveho bitu rasterregistru
                bpl     i1302      
                
                lda     #%00111011  ;25 radek, jemna grafika
                sta     $d011
                cli     
                rts


;

i130e           pla
                sta $01
                pla     
                tay     
                pla     
                tax     
                pla     
                rti     

;
; obsluha zobrazeni  (IRQ)   ;pri rastru #$2f

i1317           pha      ;zaloha A              3cyk
                lda $01  ;                      3cyk
                sta $fc  ;zaloha $01            3cyk
                                                
                lda #$35 ; '5'                  2cyk
                sta $01  ;                      3cyk
                
                lda #<i1339 ;IRQ pro dalsi frame  2cyk
                sta $fffe ;                     4cyk
                
                lda #$30  ;                     2cyk
                sta $d012 ; cislo rasterline    4cyk
                
                dec $d019 ;                     6cyk
                cli       ;                     2cyk
                nop     
                nop     
                nop     
                nop     
                nop     
                nop     
                nop     
                nop     
                nop     
                nop     
                nop                             ;22 cyks
                                                ;celkem 56 cyklu
                                                
;------------------------------------------------                     
i1339           nop     
                nop     
                nop     
                nop     
                nop     ;10 taktu
                     
                pla     ;vynda adresu1         ;4cyk
                pla     ;vynda adresu2         ;4cyk
                pla     ;vynda status          ;4cyk
                
                txa     ;ulozi X
                pha     
                tya     ;ulozi Y
                pha     
                lda $fc   ;ulozi $01 do zasobniku pro pozdejsi obnovu
                pha
                     
                jsr $8400  ;zobrazeni, nastaveni barev pro cely screen
                dec $d019
                
                lda $d016
                eor #%00000001
                sta $d016 ;zarolovani ve smeru osy X (posuv pro interlace)
                
                lda $dd00
                eor #%00000010 ;prepnuti mezi 1/3 videostrankou
                sta $dd00      ;nastaveni VIDEO banky
                
                lda #$2f       ;
                sta $d012      ;cislo puvodni rasterline
                
                lda #<i1317    ;puvodni IRQ
                sta $fffe
                lda #>i1317
                sta $ffff
                
                jmp i130e  ;return from IRQ

;

;               s u b r o u t i n e

print2screen    sta print_ptr0
                sty print_ptr1
                
                ldy #0
i1376           lda (print_ptr0),y
                beq i1380
                jsr chrout
                iny    
                bne i1376
i1380           rts

;
aFunpaintMt     .text "FUNPAINT (MT) "
error_txt       .text $0d,"LOAD-ERROR !",$0d,0


utilname_txt    .byte $93      ;clrscr
                .text "FLI-INTERLACE VIEWER FOR FUNPAINT-II PIC"
                .text "         BY TOMAS PRIBYL 1999",$0d
                .text "  SHOW ROUTINE BY MANFRED TRENZ 1991",$0d
                .text "           SUPER CPU FIXED",$0d,0
                
input_txt       .text $0d,"INPUT FILENAME:",0

novalid_txt     .text $0d,"FILE IS NO FUNPAINT II-PICTURE!",$0d,0

compressed_txt  .text $0d,"RLC COMPRESSION DETECTED...",$0d
                .text "READING AND DECODING, PLEASE WAIT...",$0d,0
                
noncompres_txt  .text $0d,"LOADING NON COMPRESSED PICTURE...",$0d,0


mansign         .byte 0
filename        .text "0123456789ABCDEF"

